

public class Evaluable {
  
  static String SUBJECT_ROLE = "subject";
  static String TEXT_TYPE = "text";
  static String VAR_TYPE = "var";
  static String STRIP_VAR_TYPE = "stripVar";
  static String TAG_TYPE = "tag";
  
  static String[] tagLookup = {
    "e", "\\emph{",
    "ee", "}"
  };
  static boolean tagsActive = false;
  
  String grammaticalRole = null;
  
  String type;
  
  String tag;
  String text;
  int varNum;

  public Evaluable(String t) {type = t;}  
  
  public static void setTagsActive(boolean active) {
    tagsActive = active;
  }
  
  public String eval(String[] vars) {
    String s = "";
    if (type.equals(TEXT_TYPE)) {
      s = text;
    } else if (type.equals(VAR_TYPE)) {
      s = vars[varNum];
    } else if (type.equals(STRIP_VAR_TYPE)) {
      s = ddStrip(vars[varNum]);
    } else if (type.equals(TAG_TYPE)) {
    //For now, all that a tag type can do is return a string, which we get
    //from a lookup table, on the basis of the tag.
    //We also provide a method with which to turn tags on or off.
    //To do anything more general, we're going to have
    //to really restructure things.
      if (tag!=null && tagsActive) {
        s = tagEffect(tag);
      }
    }
    return s;
  }
  
  private String tagEffect(String t) {
    String s = "";
    if (tagLookup!=null) {
      for (int i = 0; i < tagLookup.length/2; i++) {
        if (tagLookup[2*i].equals(t)) {
          s = tagLookup[2*i+1]; break;
        }
      }
    }
    return s;
  }
  
  public static String ddStrip(String s) {
  //Takes out *all* the dollar signs, not just pre- and post-fixed ones.
    if (s!=null && s.length()>0) {
      StringBuffer sb = new StringBuffer();
      char c;
      for (int i = 0; i < s.length(); i++) {
        c = s.charAt(i);
        if (c!='$') {sb.append(c);}
      }
      s = new String(sb);
    }
    return s;
  }

}
