 

import java.util.HashMap;

public class NLUnique extends NLTerm {

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  NLTerm t;
  NLInfixrel alpha;
  NLFormula phi,psi;
  NLTerm[] tt,vv;
  
  String translation = "";
  boolean isInWords = false;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public NLUnique(NLTerm t, NLInfixrel alpha, NLTerm[] tt,
                  NLFormula phi, NLFormula psi, NLTerm[] vv
  ) {
    this.t = t; this.alpha = alpha; this.tt = tt;
    this.phi = phi; this.psi = psi; this.vv = vv;
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------
  
  public String xlat(int mode) {
    //First call the xlat methods of the children, and figure out
    //if we are forced to return words.
    //Start with the term t.
    t.xlat(mode);
    //Now treat the prepositional alpha, if it is there.
    if (alpha!=null) {
      boolean prepWords = t.isInWords();
      if (tt==null) {System.err.println("Prep. infix w/o RHS!");} else {
        for (int i = 0; i < tt.length; i++) {
          tt[i].xlat(mode); prepWords |= tt[i].isInWords();
        }
      }
      if (prepWords || mode==NLPhrase.WORDS_MODE) {
        alpha.xlat(NLInfixrel.QUALIFIER_CODE);
      }
      else {alpha.xlat(NLInfixrel.DEFAULT_CODE);}
      prepWords |= alpha.isInWords();
      this.isInWords |= prepWords;
    }
    //Now phi, if it is there.
    if (phi!=null) {
      phi.xlat(mode); this.isInWords |= phi.isInWords();
    }
    //And psi, and the fixed variables, if they are there.
    if (psi!=null) {
      psi.xlat(mode); this.isInWords |= psi.isInWords();
      for (int i = 0; i < vv.length; i++) {
        vv[i].xlat(mode);
      }
    }
    //Finally, write the string.
    String x = "";
    if (this.isInWords || mode==NLPhrase.WORDS_MODE) {
      x = writeWords();
    } else {
      x = writeSymbols();
    }
    this.translation = x;
    return x;
  }

  public boolean isInWords() {
  //Don't call until *after* calling xlat.
    return isInWords;
  }

  public String getString() {return translation;}
  
  String writeSymbols() {
  //If you've settled on writing symbols, call this method to
  //produce the string.
    String s = "";
    s += "(!"+t.getString();
    if (alpha!=null) {
      s += alpha.getString();
      for (int i = 0; i < tt.length; i++) {
        s += (i>0?",":"")+tt[i].getString();
      }
    }
    s += ")";
    if (phi!=null) {
      s += phi.getString();
    } else {
      s += "("+psi.getString()+", ";
      for (int i = 0; i < vv.length; i++) {
        s += (i==0?"":",")+vv[i].getString();
      }
      s += " fixed";
    }
    s = Evaluable.ddStrip(s);
    return "$"+s+"$";
  }
  
  String writeWords() {
  //If you've settled on writing words, call this method to
  //produce the string.
    String s = "";
    s += "the unique "+t.getString();
    if (alpha!=null) {
      s += alpha.getString();
      for (int i = 0; i < tt.length; i++) {
        s += (i>0?", ":"")+tt[i].getString();
      }
    }
    s += " such that ";
    if (phi!=null) {
      s += phi.getString();
    } else {
      s += psi.getString();
      //s += ", where ";
      //for (int i = 0; i < vv.length; i++) {
      //  s += (i==0?"":", ")+vv[i];
      //}
      //s += " are fixed";
    }
    return s;
  }


// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 
